/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view.failuretests;

import java.awt.Color;
import java.awt.Font;
import java.awt.Insets;
import java.io.File;

import junit.framework.TestCase;

import com.topcoder.rules.dependencymap.view.Dependency;
import com.topcoder.rules.dependencymap.view.FixedGridLayoutManager;
import com.topcoder.rules.dependencymap.view.RendererException;
import com.topcoder.rules.dependencymap.view.SVGRenderer;
import com.topcoder.rules.dependencymap.view.ShapeFactory;

/**
 * Failure test cases for FixedGridLayoutManager.
 *
 * @author AdamSelene
 */
public class FGLTest extends TestCase {
    
	private Insets goodInset = new Insets(1,2,3,4);
	private Dependency goodDep = new Dependency("test");
	private SVGRenderer svgr = new SVGRenderer(new File("test_files/failuretests/failure_blank.svg"));
	//private SVGRender goodGraphics = svgr.getGraphics(goodDep, 1000, 1000);
	private ShapeFactory goodSF = new ShapeFactory();

	
//	/**
//     * Invalid input to constructor.
//     *
//     */
//	public void testCon_Inv() {
//        try {
//            new FixedGridLayoutManager("   ");
//            fail("Should have thrown IllegalArgumentException.");
//        } catch (IllegalArgumentException npe) { /* expected */ }
//    }
//	
//    /**
//     * Invalid input to constructor.
//     *
//     */
//	public void testCon_Inv2() {
//        try {
//            new FixedGridLayoutManager("");
//            fail("Should have thrown IllegalArgumentException.");
//        } catch (IllegalArgumentException npe) { /* expected */ }
//    }    
//	
//    /**
//     * Invalid input to constructor.
//     *
//     */
//	public void testCon_Null() {
//        try {
//            new FixedGridLayoutManager(null);
//            fail("Should have thrown NullPointerException.");
//        } catch (NullPointerException npe) { /* expected */ }
//    }  
//	
//	
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_GoodNamespace() {
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("correct");
//        assertEquals( "inv colpadding",11,fgl.getColPadding());
//        assertEquals("inv rowpadding",11,fgl.getRowPadding());
//        assertEquals("inv textMargin",11,fgl.getTextMargin());
//        assertEquals("inv font",new Font("Arial", Font.BOLD, 11),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0xFF0000),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFF0000), fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0xFF0000),fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFF0000),fgl.getArrowFillColor());
//    }  
//	
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespace() {
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("SOME_GARBAGE_NAMESPACE");
//        assertEquals( "inv colpadding",10,fgl.getColPadding());
//        assertEquals("inv rowpadding",10,fgl.getRowPadding());
//        assertEquals("inv textMargin",10,fgl.getTextMargin());
//        assertEquals("inv font",new Font("SansSerif", Font.PLAIN, 12),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFFFFFF),fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0), fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFFFFFF), fgl.getArrowFillColor());
//    }  
//    
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespace2() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("testns1");
//        assertEquals( "inv colpadding",10,fgl.getColPadding());
//        assertEquals("inv rowpadding",11,fgl.getRowPadding());
//        assertEquals("inv textMargin",11,fgl.getTextMargin());
//        assertEquals("inv font",new Font("Arial", Font.BOLD, 10),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0xFF0000),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFF0000), fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0xFF0000),fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFF0000),fgl.getArrowFillColor());
//    }  
//    
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespace3() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("testns2");
//        assertEquals( "inv colpadding",11,fgl.getColPadding());
//        assertEquals("inv rowpadding",10,fgl.getRowPadding());
//        assertEquals("inv textMargin",11,fgl.getTextMargin());
//        assertEquals("inv font",new Font("Arial", Font.BOLD, 10),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0xFF0000),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFF0000), fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0xFF0000),fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFF0000),fgl.getArrowFillColor());
//    }  
//
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespace4() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("testns3");
//        assertEquals( "inv colpadding",10,fgl.getColPadding());
//        assertEquals("inv rowpadding",11,fgl.getRowPadding());
//        assertEquals("inv textMargin",11,fgl.getTextMargin());
//        assertEquals("inv font",new Font("Arial", Font.BOLD, 10),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0xFF0000),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFF0000), fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0xFF0000),fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFF0000),fgl.getArrowFillColor());
//    }  
//
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespace5() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("testns4");
//        assertEquals( "inv colpadding",11,fgl.getColPadding());
//        assertEquals("inv rowpadding",11,fgl.getRowPadding());
//        assertEquals("inv textMargin",11,fgl.getTextMargin());
//        assertEquals("inv font",new Font("Arial", Font.PLAIN, 10),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0xFF0000),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFF0000), fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0xFF0000),fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFF0000),fgl.getArrowFillColor());
//    }  
//
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespace6() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("testns5");        
//        assertEquals( "inv colpadding",10,fgl.getColPadding());
//        assertEquals("inv rowpadding",10,fgl.getRowPadding());
//        assertEquals("inv textMargin",10,fgl.getTextMargin());
//        assertEquals("inv font",new Font("Arial", Font.PLAIN, 12),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFFFFFF),fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0), fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFFFFFF), fgl.getArrowFillColor());
//    }  
//    
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespace7() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("testns6");        
//        assertEquals( "inv colpadding",10,fgl.getColPadding());
//        assertEquals("inv rowpadding",10,fgl.getRowPadding());
//        assertEquals("inv textMargin",10,fgl.getTextMargin());
//        assertEquals("inv font",new Font("Arial", Font.PLAIN, 12),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFFFFFF),fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0), fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFFFFFF), fgl.getArrowFillColor());
//    }  
//    
//
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespace8() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("testns7");        
//        assertEquals( "inv colpadding",10,fgl.getColPadding());
//        assertEquals("inv rowpadding",10,fgl.getRowPadding());
//        assertEquals("inv textMargin",10,fgl.getTextMargin());
//        assertEquals("inv font",new Font("Arial", Font.PLAIN, 12),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFFFFFF),fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0), fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFFFFFF), fgl.getArrowFillColor());
//    }  
//    
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespace9() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("testns8");        
//        assertEquals( "inv colpadding",10,fgl.getColPadding());
//        assertEquals("inv rowpadding",10,fgl.getRowPadding());
//        assertEquals("inv textMargin",11,fgl.getTextMargin());
//        assertEquals("inv font",new Font("SansSerif", Font.PLAIN, 12),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFFFFFF),fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0), fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFFFFFF), fgl.getArrowFillColor());
//    }  
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BoldItalic() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("bolditalic");
//        assertEquals( "inv colpadding",11,fgl.getColPadding());
//        assertEquals("inv rowpadding",11,fgl.getRowPadding());
//        assertEquals("inv textMargin",11,fgl.getTextMargin());
//        assertEquals("inv font",new Font("Arial", Font.BOLD | Font.ITALIC, 10),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0xFF0000),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFF0000), fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0xFF0000),fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFF0000),fgl.getArrowFillColor());
//    }  
//	
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespaceBadFont() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("bf1");
//        assertEquals( "inv colpadding",11,fgl.getColPadding());
//        assertEquals("inv rowpadding",11,fgl.getRowPadding());
//        assertEquals("inv textMargin",11,fgl.getTextMargin());
//        assertEquals("inv font",new Font("SansSerif", Font.BOLD, 10),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0xFF0000),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFF0000), fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0xFF0000),fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFF0000),fgl.getArrowFillColor());
//    }  
//
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespaceBadFont2() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("bf2");        
//        assertEquals( "inv colpadding",10,fgl.getColPadding());
//        assertEquals("inv rowpadding",10,fgl.getRowPadding());
//        assertEquals("inv textMargin",10,fgl.getTextMargin());
//        assertEquals("inv font",new Font("SansSerif", Font.PLAIN, 12),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFFFFFF),fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0), fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFFFFFF), fgl.getArrowFillColor());
//    }  
//    
//
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testCon_BadNamespaceBadFont3() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager("bf3");        
//        assertEquals( "inv colpadding",10,fgl.getColPadding());
//        assertEquals("inv rowpadding",10,fgl.getRowPadding());
//        assertEquals("inv textMargin",10,fgl.getTextMargin());
//        assertEquals("inv font",new Font("SansSerif", Font.PLAIN, 12),fgl.getTextFont());
//        assertEquals("inv line color", new Color(0),fgl.getShapeLineColor());
//        assertEquals( "inv shape f", new Color(0xFFFFFF),fgl.getShapeFillColor());
//        assertEquals("inv arrow c", new Color(0), fgl.getArrowLineColor());
//        assertEquals("inv arrow f	", new Color(0xFFFFFF), fgl.getArrowFillColor());
//    }  
//    
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testSetIAE1() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager();
//        
//        try {
//        	fgl.setColPadding(-1);
//        	fail("should have thrown iae1");
//        } catch (IllegalArgumentException iae) {}
//        
//        try {
//        	fgl.setRowPadding(-1);
//        	fail("should have thrown iae1");
//        } catch (IllegalArgumentException iae) {}
//        
//        try {
//        	fgl.setTextMargin(-1);
//        	fail("should have thrown iae1");
//        } catch (IllegalArgumentException iae) {}       
//    }  
//    
//    /**
//     * Invalid input to constructor.
//     *
//     */
//    public void testSetNull() {
//
//        FixedGridLayoutManager fgl = new FixedGridLayoutManager();
//        
//        try {
//        	fgl.setArrowFillColor(null);
//        	fail("should have thrown iae1");
//        } catch (NullPointerException iae) {}
//        
//        try {
//        	fgl.setShapeFillColor(null);
//        	fail("should have thrown npe");
//        } catch (NullPointerException iae) {}
//        try {
//        	fgl.setArrowLineColor(null);
//        	fail("should have thrown iae1");
//        } catch (NullPointerException iae) {}
//        
//        try {
//        	fgl.setShapeLineColor(null);
//        	fail("should have thrown npe");
//        } catch (NullPointerException iae) {}
//
//    
//    }  
    
    /**
     * Valid input to layout.
     *
     */
	public void testLayout_Silent() throws RendererException {
        new FixedGridLayoutManager().layout(goodDep, goodSF, svgr);
    }

	
	/**
     * Invalid input to layout.
     *
     */
	public void testLayout_N1() throws RendererException {
        try {
            new FixedGridLayoutManager().layout(null, goodSF, svgr);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) { /* expected */ }
    }

	/**
     * Invalid input to layout.
     *
     */
	public void testLayout_N2() throws RendererException {
        try {
            new FixedGridLayoutManager().layout(goodDep, null, svgr);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) { /* expected */ }
    }

	/**
     * Invalid input to layout.
     *
     */
	public void testLayout_N3() throws RendererException {
        try {
            new FixedGridLayoutManager().layout(goodDep, goodSF, null);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) { /* expected */ }
    }

	/**
     * Invalid input to layout.
     *
     */
	public void testLayout_N4() throws RendererException {
        try {
            new FixedGridLayoutManager().layout(null, null, svgr);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) { /* expected */ }
    }

	/**
     * Invalid input to layout.
     *
     */
	public void testLayout_N5() throws RendererException {
        try {
            new FixedGridLayoutManager().layout(null, goodSF, null);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) { /* expected */ }
    }

	/**
     * Invalid input to layout.
     *
     */
	public void testLayout_N6() throws RendererException {
        try {
            new FixedGridLayoutManager().layout(goodDep, null, null);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) { /* expected */ }
    }

	/**
     * Invalid input to layout.
     *
     */
	public void testLayout_N7() throws RendererException {
        try {
            new FixedGridLayoutManager().layout(null, null, null);
            fail("Should have thrown NullPointerException.");
        } catch (NullPointerException npe) { /* expected */ }
    }	
}