/*
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights reserved.
 *
 * Author: TCSDeveloper
 */

using System;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;
using NUnit.Framework;

namespace TopCoder.Rules.DependencyMap.View
{   
    /// <summary>
    /// Failure test fixture for FGL.
    /// </summary>
    [TestFixture]
    public class G2DTests
    {
        Dependency goodDep = new Dependency("test");
        private IDiagramRenderer goodRenderer = new SVGRenderer(".");
        private ShapeFactory goodSF = new ShapeFactory();
    	
        /// <summary>
        /// Invalid input to constructor.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentNullException))]
        public void testNull1() 
        {
            new GraphicsAdapter(null);
        }
        
        /// <summary>
        /// Invalid input to constructor.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentNullException))]
        public void testNull122x() 
        {
            new GraphicsAdapter(Graphics.FromImage(new Bitmap(10,10))).DrawPath(null, null);
        }

        /// <summary>
        /// Invalid input to constructor.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentNullException))]
        public void testNull122() 
        {
            new GraphicsAdapter(Graphics.FromImage(new Bitmap(10,10))).DrawString(null, null, null, new PointF(0,0));
        }

        /// <summary>
        /// Invalid input to constructor.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentNullException))]
        public void testNull123() 
        {
            new GraphicsAdapter(Graphics.FromImage(new Bitmap(10,10))).MeasureString(null, null);
        }
        /// <summary>
        /// Invalid input to constructor.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentNullException))]
        public void testNull13() 
        {
            new GraphicsAdapter(null);
        }

        /// <summary>
        /// Invalid input to constructor.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentNullException))]
        public void testGG_Inv2() 
        {
            new BitMapRenderer(PixelFormat.Format24bppRgb).GetGraphics(null, 1,1);
        }    

        /// <summary>
        /// Invalid input to constructor.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void testGG_Inv22() 
        {
            new BitMapRenderer(PixelFormat.Format24bppRgb).GetGraphics(new Dependency("test"), -1,1);
        }    
	
        /// <summary>
        /// Invalid input to constructor.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void testGG_Inv23() 
        {
            new BitMapRenderer(PixelFormat.Format24bppRgb).GetGraphics(new Dependency("test"), 1,-1);
        }   
    }
}
